SystemOrganization addCategory: #'Pier-Security-Model'!
SystemOrganization addCategory: #'Pier-Security-Command'!
SystemOrganization addCategory: #'Pier-Security-Seaside'!

PRCommand subclass: #PUChangeSecurity
	instanceVariableNames: 'recursive operation commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

PUChangeSecurity subclass: #PUChangeGroup
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PUChangeGroup class methodsFor: 'accessing-description' stamp: 'lr 1/7/2006 14:44'!
descriptionGroup
	^ (MASingleOptionDescription selector: #group label: 'Group' priority: 200)
		options: (MADynamicObject on: [ self groupInstances ]);
		reference: PUGroup description;
		undefined: '(unchanged)';
		beSorted;
		yourself.! !

!PUChangeGroup class methodsFor: 'testing' stamp: 'lr 12/20/2005 09:35'!
isAbstract
	^ false! !

!PUChangeGroup class methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:34'!
label
	^ 'Change Group'! !

!PUChangeGroup methodsFor: 'configuration' stamp: 'lr 12/20/2005 16:02'!
commandAccessor
	^ MACascadeAccessor selectors: #( securityDecoration groupCommands ).! !

!PUChangeGroup methodsFor: 'events' stamp: 'lr 12/20/2005 15:53'!
doExecuteFor: aStructure
	self group notNil
		ifTrue: [ aStructure securityDecoration group: self group ].
	super doExecuteFor: aStructure.! !

!PUChangeGroup methodsFor: 'events' stamp: 'lr 12/20/2005 10:19'!
doInitialize
	super doInitialize.
	self group: self structure group.! !

!PUChangeGroup methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:39'!
group
	^ group! !

!PUChangeGroup methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:40'!
group: aGroup
	group := aGroup! !

PUChangeSecurity subclass: #PUChangeOther
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PUChangeOther class methodsFor: 'testing' stamp: 'lr 12/20/2005 10:33'!
isAbstract
	^ false! !

!PUChangeOther class methodsFor: 'accessing' stamp: 'lr 12/20/2005 10:32'!
label
	^ 'Change Other'! !

!PUChangeOther methodsFor: 'configuration' stamp: 'lr 12/20/2005 16:02'!
commandAccessor
	^ MACascadeAccessor selectors: #( securityDecoration otherCommands ).! !

PUChangeSecurity subclass: #PUChangeOwner
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PUChangeOwner class methodsFor: 'accessing-description' stamp: 'lr 1/7/2006 14:43'!
descriptionOwner
	^ (MASingleOptionDescription selector: #owner label: 'Owner' priority: 200)
		options: (MADynamicObject on: [ self userInstances ]);
		reference: PUUser description;
		undefined: '(unchanged)';
		beSorted;
		yourself.! !

!PUChangeOwner class methodsFor: 'testing' stamp: 'lr 12/20/2005 09:35'!
isAbstract
	^ false! !

!PUChangeOwner class methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:35'!
label
	^ 'Change Owner'! !

!PUChangeOwner methodsFor: 'configuration' stamp: 'lr 12/20/2005 16:02'!
commandAccessor
	^ MACascadeAccessor selectors: #( securityDecoration ownerCommands ).! !

!PUChangeOwner methodsFor: 'events' stamp: 'lr 12/20/2005 15:53'!
doExecuteFor: aStructure
	self owner notNil
		ifTrue: [ aStructure securityDecoration owner: self owner ].
	super doExecuteFor: aStructure.! !

!PUChangeOwner methodsFor: 'events' stamp: 'lr 12/20/2005 10:19'!
doInitialize
	super doInitialize.
	self owner: self structure owner.! !

!PUChangeOwner methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:41'!
owner
	^ owner! !

!PUChangeOwner methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:40'!
owner: anUser
	owner := anUser! !

!PUChangeSecurity class methodsFor: 'private' stamp: 'lr 1/7/2006 14:46'!
commandClasses
	^ PRCommand withAllConcreteClasses asSet
		remove: PULogin;
		remove: PULogout;
		yourself.! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 23:58'!
descriptionCommands
	^ (MAMultipleOptionDescription selector: #commands label: 'Commands' priority: 400)
		options: (MADynamicObject on: [ self commandClasses ]);
		reference: MAClassDescription new;
		beSorted;
		yourself.! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 15:57'!
descriptionOperation
	^ (MASingleOptionDescription selector: #operation label: 'Operation' priority: 300)
		reference: MASymbolDescription new;
		options: #( set add clear );
		undefined: '(unchanged)';
		yourself.! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 10:33'!
descriptionRecursive
	^ (MABooleanDescription selector: #recursive label: 'Recursive' priority: 100)
		beRequired;
		yourself.! !

!PUChangeSecurity class methodsFor: 'private' stamp: 'lr 12/23/2005 20:45'!
groupInstances
	^ PRCurrentContext value kernel groups.! !

!PUChangeSecurity class methodsFor: 'private' stamp: 'lr 12/23/2005 20:45'!
userInstances
	^ PRCurrentContext value kernel users.! !

!PUChangeSecurity methodsFor: 'configuration' stamp: 'lr 12/21/2005 09:42'!
commandAccessor
	self subclassResponsibility.! !

!PUChangeSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:05'!
commands
	^ commands! !

!PUChangeSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:33'!
commands: aCollectionOfCommands
	commands := aCollectionOfCommands asSet! !

!PUChangeSecurity methodsFor: 'events' stamp: 'lr 12/20/2005 10:40'!
doExecute
	super doExecute.
	self doExecuteFor: self structure.
	self recursive ifTrue: [
		self structure allChildrenDo: [ :each |
			self doExecuteFor: each ] ].! !

!PUChangeSecurity methodsFor: 'events' stamp: 'lr 12/20/2005 16:19'!
doExecuteFor: aStructure
	"Apply the changes to aStructure. Override this method and call super, it will be automatically called by #doExecute for all the requested structure."

	self commandAccessor 
		write: (self operation = #set 
			ifTrue: [ self commands copy ]
			ifFalse: [
				self operation = #add
					ifTrue: [ 
						(self commandAccessor read: aStructure) 
							copyWithAll: self commands ]
					ifFalse: [
						self operation = #clear
							ifTrue: [ 
								(self commandAccessor read: aStructure) 
									copyWithoutAll: self commands ]
							ifFalse: [ ^ self ] ] ])
		to: aStructure.! !

!PUChangeSecurity methodsFor: 'events' stamp: 'lr 12/20/2005 16:15'!
doInitialize
	super doInitialize.
	self recursive: true; operation: #set.
	self commands: (self commandAccessor 
		read: self structure).! !

!PUChangeSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 15:49'!
operation
	^ operation! !

!PUChangeSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 15:49'!
operation: aSymbol
	operation := aSymbol! !

!PUChangeSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:33'!
recursive
	^ recursive! !

!PUChangeSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:33'!
recursive: aBoolean
	recursive := aBoolean! !

PRCommand subclass: #PULogin
	instanceVariableNames: 'username password user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PULogin class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 11:44'!
descriptionPassword
	^ (MAPasswordDescription selector: #password label: 'Password' priority: 200)
		beRequired;
		yourself.! !

!PULogin class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 11:44'!
descriptionUsername
	^ (MAStringDescription selector: #username label: 'Username' priority: 100)
		beRequired;
		yourself.! !

!PULogin class methodsFor: 'testing' stamp: 'lr 12/20/2005 11:44'!
isAbstract
	^ false! !

!PULogin class methodsFor: 'testing' stamp: 'lr 12/21/2005 23:43'!
isValidIn: aContext
	^ aContext isLoggedIn not.! !

!PULogin class methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:44'!
label
	^ 'Login'! !

!PULogin methodsFor: 'events' stamp: 'lr 12/20/2005 11:54'!
doAnswer
	super doAnswer.
	self answer setUser: self user.! !

!PULogin methodsFor: 'events' stamp: 'lr 12/20/2005 11:45'!
doInitialize
	super doInitialize.
	self username: String new.
	self password: String new.! !

!PULogin methodsFor: 'events' stamp: 'lr 1/7/2006 14:45'!
doValidate
	super doValidate.
	self user: (self kernel users
		detect: [ :each |
			each name = self username 
				and: [ each validatePassword: self password ] ]
		ifNone: [ PUInvalidLogin signal: 'Invalid username or password.' ]).! !

!PULogin methodsFor: 'testing' stamp: 'lr 12/20/2005 11:54'!
isLogged
	^ false! !

!PULogin methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:43'!
password
	^ password! !

!PULogin methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:43'!
password: aString
	password := aString! !

!PULogin methodsFor: 'private' stamp: 'lr 12/20/2005 11:53'!
user
	^ user! !

!PULogin methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:43'!
username
	^ username! !

!PULogin methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:43'!
username: aString
	username := aString! !

!PULogin methodsFor: 'private' stamp: 'lr 12/20/2005 11:53'!
user: aUser
	user := aUser! !

PRCommand subclass: #PULogout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PULogout class methodsFor: 'testing' stamp: 'lr 12/20/2005 11:56'!
isAbstract
	^ false! !

!PULogout class methodsFor: 'testing' stamp: 'lr 12/21/2005 23:43'!
isValidIn: aContext
	^ aContext isLoggedIn.! !

!PULogout class methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:56'!
label
	^ 'Logout'! !

!PULogout methodsFor: 'events' stamp: 'lr 12/20/2005 11:55'!
doAnswer
	super doAnswer.
	self answer setUser: nil.! !

!PULogout methodsFor: 'testing' stamp: 'lr 12/20/2005 11:55'!
isLogged
	^ false! !

!PULogout methodsFor: 'testing' stamp: 'lr 12/20/2005 12:13'!
isQuick
	^ true! !

PRDecoration subclass: #PUSecurity
	instanceVariableNames: 'owner ownerCommands group groupCommands otherCommands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PUSecurity commentStamp: 'lr 12/20/2005 15:05' prior: 0!
Every structure is owned by a specific user. The owner of an object comprises its user class. Permissions assigned to the user class only apply to that specific user. A structure is also assigned a group, which comprises its group class. Permissions assigned to the group class only apply to members of that group. Users who are not otherwise represented by the other two classes comprise a file's others class.

The effective permissions that have applied to a specific user in relation to a file are determined in logical precedence. For example, the user who owns the file will have the effective permissions given to the user class regardless of those assigned to the group or others class.!

!PUSecurity class methodsFor: 'testing' stamp: 'lr 12/20/2005 10:26'!
isAbstract
	^ false! !

!PUSecurity class methodsFor: 'events' stamp: 'lr 1/5/2006 14:31'!
onStructureAdded: aStructure
	| context decoration |
	context := PRCurrentContext value.
	decoration := aStructure isRoot
		ifFalse: [ aStructure parent securityDecoration copy ]
		ifTrue: [ aStructure securityDecorationClass new ].
	context isNil ifFalse: [
		decoration
			owner: context user;
			group: (context user 
				ifNotNil: [ context user group ]) ].
	aStructure addDecoration: decoration ifPresent: [ ].! !

!PUSecurity methodsFor: 'visiting' stamp: 'lr 12/20/2005 14:31'!
accept: aVisitor
	aVisitor visitSecurity: self.! !

!PUSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:30'!
group
	^ group! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 12/20/2005 10:56'!
groupCommands
	^ groupCommands! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 12/20/2005 10:56'!
groupCommands: aSet
	groupCommands := aSet! !

!PUSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 10:12'!
group: aGroup
	group := aGroup! !

!PUSecurity methodsFor: 'initialization' stamp: 'lr 1/5/2006 14:11'!
initialize
	super initialize.
	self ownerCommands: PRCommand withAllConcreteClasses asSet.
	self groupCommands: PRCommand withAllConcreteClasses asSet.
	self otherCommands: (Array with: PRViewCommand) asSet.! !

!PUSecurity methodsFor: 'testing' stamp: 'lr 1/5/2006 14:15'!
isValidCommand: aCommandClass in: aContext
	(aContext user notNil and: [ aContext user isSuperuser ])
		ifTrue: [ ^ true ].
	(self owner = aContext user)
		ifTrue: [ ^ self ownerCommands includes: aCommandClass ].
	(self group notNil and: [ self group includes: aContext user ])
		ifTrue: [ ^ self groupCommands includes: aCommandClass ].
	^ self otherCommands includes: aCommandClass.! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 12/20/2005 10:57'!
otherCommands
	^ otherCommands! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 12/20/2005 10:56'!
otherCommands: aSet
	otherCommands := aSet! !

!PUSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 15:04'!
owner
	^ owner! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 12/20/2005 15:04'!
ownerCommands
	^ ownerCommands! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 12/20/2005 15:04'!
ownerCommands: aSet
	ownerCommands := aSet! !

!PUSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 15:04'!
owner: anUser
	owner := anUser! !

!PUSecurity methodsFor: 'copying' stamp: 'lr 12/20/2005 15:07'!
postCopy
	super postCopy.
	self ownerCommands: self ownerCommands copy.
	self groupCommands: self groupCommands copy.
	self otherCommands: self otherCommands copy.! !

!PUSecurity methodsFor: 'configuration' stamp: 'lr 12/20/2005 10:16'!
priority
	^ -200! !

PRWidget subclass: #PUSecurityWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Seaside'!

!PUSecurityWidget class methodsFor: 'accessing-defaults' stamp: 'lr 12/20/2005 12:28'!
defaultCssClass
	^ 'box security'! !

!PUSecurityWidget class methodsFor: 'testing' stamp: 'lr 12/20/2005 12:25'!
isAbstract
	^ false! !

!PUSecurityWidget class methodsFor: 'accessing' stamp: 'lr 12/20/2005 14:17'!
label
	^ 'Security'! !

!PUSecurityWidget methodsFor: 'rendering' stamp: 'lr 1/5/2006 14:10'!
renderCommands: aCollection on: html
	| labels |
	labels := aCollection collect: #label.
	html unorderedList: [
		labels asSortedCollection do: [ :each |
			html listItem: each ] ].! !

!PUSecurityWidget methodsFor: 'rendering' stamp: 'lr 1/5/2006 14:09'!
renderContext: aDecoration on: html
	html strong: 'Context'.
	html unorderedList: [
		html listItem: [
			html strong: 'Owner: '; render: aDecoration owner name.
			self renderCommands: aDecoration ownerCommands on: html ].
		html listItem: [
			html strong: 'Group: '; render: aDecoration group name.
			self renderCommands: aDecoration groupCommands on: html ].
		html listItem: [
			html strong: 'Other:'.
			self renderCommands: aDecoration otherCommands on: html ] ].! !

!PUSecurityWidget methodsFor: 'rendering' stamp: 'lr 1/5/2006 14:02'!
renderUser: aUser on: html
	html strong: 'User'.
	html unorderedList: [
		html listItem: [
			html 
				strong: 'Name: ';
				render: aUser name ].
		html listItem: [
			html strong: 'Groups: '.
			aUser groups 
				do: [ :each | html render: each name ]
				separatedBy: [ html text: ', ' ] ] ].! !

!PUSecurityWidget methodsFor: 'rendering' stamp: 'lr 1/5/2006 14:02'!
renderWidgetOn: html
	html unorderedList: [
		self context isLoggedIn
			ifTrue: [ html listItem: [ self renderUser: self context user on: html ] ].
		html listItem: [ self renderContext: self context structure securityDecoration on: html ] ].! !

!PRStructure class methodsFor: '*pier-security' stamp: 'lr 1/7/2006 14:44'!
descriptionGroup
	^ (MAOneToOneRelationDescription selector: #group label: 'Group' priority: 120)
		classes: (Array with: PUGroup);
		yourself.! !

!PRStructure class methodsFor: '*pier-security' stamp: 'lr 1/7/2006 14:43'!
descriptionOwner
	^ (MAOneToOneRelationDescription selector: #owner label: 'Owner' priority: 110)
		classes: (Array with: PUUser);
		yourself.! !

!PRStructure methodsFor: '*pier-security-accessing' stamp: 'lr 12/20/2005 14:05'!
group
	"Answer the owning-group of the file."

	^ self securityDecoration group.! !

!PRStructure methodsFor: '*pier-security-accessing' stamp: 'lr 12/20/2005 14:05'!
owner
	"Answer the owning-user of the receiver."
	
	^ self securityDecoration owner.! !

!PRStructure methodsFor: '*pier-security-decorations' stamp: 'lr 1/5/2006 13:55'!
securityDecoration
	^ self 
		decorationOfClass: self securityDecorationClass
		ifAbsent: [ 
			self securityDecorationClass 
				onStructureAdded: self.
			self securityDecoration ].! !

!PRStructure methodsFor: '*pier-security-decorations' stamp: 'lr 1/7/2006 14:43'!
securityDecorationClass
	^ PUSecurity! !

MADistribution subclass: #PUDistribution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PUDistribution class methodsFor: 'accessing' stamp: 'lr 1/7/2006 15:08'!
package
	"The SqueakMap package name."

	^ 'Pier Unix Security'! !

!PUDistribution class methodsFor: 'accessing' stamp: 'lr 1/7/2006 14:48'!
packages
	^ #( ( 'Pier-Security' ) )! !

!PUDistribution class methodsFor: 'accessing' stamp: 'lr 1/7/2006 15:00'!
preamble
	^ '(SMSqueakMap default packageWithName: ''Pier'')
	lastRelease install.' , String cr.! !

!PUDistribution class methodsFor: 'accessing' stamp: 'lr 1/7/2006 15:09'!
version
	"The first item is the product name, which should only contain lowercase letters. Then the version numbers are following, that are made up of three numbers. An optimal suffix alpha, beta, pre or rc follows. External packages or extensions might want to call this method to check the version required to run."

	^ #( pierunixsecurity 1 0 0 alpha )! !

!PRContext methodsFor: '*pier-security-testing' stamp: 'lr 12/20/2005 12:32'!
isLoggedIn
	^ self user notNil.! !

!PRContext methodsFor: '*pier-security-initialization' stamp: 'lr 12/20/2005 12:16'!
setUser: aUser
	self propertyAt: #user put: aUser.! !

!PRContext methodsFor: '*pier-security-accessing' stamp: 'lr 1/5/2006 14:14'!
user
	^ self propertyAt: #user ifAbsentPut: [ nil ].! !

!PRVisitor methodsFor: '*pier-security-visiting-structure' stamp: 'lr 12/20/2005 14:35'!
visitSecurity: anObject
	self visitDecoration: anObject! !

PRObject subclass: #PUMember
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

PUMember subclass: #PUGroup
	instanceVariableNames: 'users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PUGroup class methodsFor: 'testing' stamp: 'lr 12/20/2005 10:14'!
isAbstract
	^ false! !

!PUGroup methodsFor: 'testing' stamp: 'lr 12/20/2005 15:13'!
includes: anUser
	^ self users includes: anUser.! !

!PUGroup methodsFor: 'initialization' stamp: 'lr 1/5/2006 13:44'!
initialize
	super initialize.
	users := OrderedCollection new.! !

!PUGroup methodsFor: 'accessing-readonly' stamp: 'lr 12/20/2005 14:51'!
users
	^ users! !

!PUMember class methodsFor: 'accessing-description' stamp: 'lr 1/5/2006 13:48'!
descriptionName
	^ (MAStringDescription selector: #name label: 'Name')
		beReadonly;
		yourself.! !

!PUMember class methodsFor: 'instance-creation' stamp: 'lr 1/5/2006 13:47'!
named: aString
	^ self new
		setName: aString;
		yourself.! !

!PUMember methodsFor: 'comparing' stamp: 'lr 1/5/2006 13:43'!
hash
	^ self class hash bitXor: self name hash.! !

!PUMember methodsFor: 'accessing' stamp: 'lr 12/20/2005 10:13'!
name
	^ name! !

!PUMember methodsFor: 'printing' stamp: 'lr 12/20/2005 10:14'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name.! !

!PUMember methodsFor: 'initialize-release' stamp: 'lr 1/5/2006 13:47'!
setName: aString
	name := aString! !

!PUMember methodsFor: 'comparing' stamp: 'lr 1/5/2006 13:43'!
= anObject
	^ self class = anObject class
		and: [ self name = anObject name ].! !

PUMember subclass: #PUUser
	instanceVariableNames: 'password groups superuser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PUUser class methodsFor: 'testing' stamp: 'lr 12/20/2005 10:14'!
isAbstract
	^ false! !

!PUUser methodsFor: 'utilties' stamp: 'lr 12/20/2005 14:53'!
addGroup: aGroup
	self groups add: aGroup.
	aGroup users add: self.! !

!PUUser methodsFor: 'accessing-readonly' stamp: 'lr 1/5/2006 11:44'!
group
	^ self groups first.! !

!PUUser methodsFor: 'accessing-readonly' stamp: 'lr 12/20/2005 12:52'!
groups
	^ groups! !

!PUUser methodsFor: 'initialization' stamp: 'lr 1/5/2006 11:44'!
initialize
	super initialize.
	groups := OrderedCollection new.
	superuser := false.! !

!PUUser methodsFor: 'testing' stamp: 'lr 1/5/2006 11:35'!
isSuperuser
	^ self superuser.! !

!PUUser methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:35'!
password
	^ String new: 10 withAll: $*.! !

!PUUser methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:39'!
password: aString
	password := PRCompatibility hashPassword: aString.! !

!PUUser methodsFor: 'utilties' stamp: 'lr 12/20/2005 14:53'!
removeGroup: aGroup
	self groups remove: aGroup.
	aGroup users remove: self.! !

!PUUser methodsFor: 'accessing' stamp: 'lr 1/5/2006 11:34'!
superuser
	^ superuser! !

!PUUser methodsFor: 'accessing' stamp: 'lr 1/5/2006 11:34'!
superuser: aBoolean
	superuser := aBoolean! !

!PUUser methodsFor: 'validating' stamp: 'lr 12/20/2005 12:22'!
validatePassword: aString
	^ aString isEmptyOrNil not
		and: [ (PRCompatibility hashPassword: aString) = password ].! !

!PRKernel methodsFor: '*pier-security-defaults' stamp: 'lr 1/7/2006 14:44'!
adminGroup
	^ self 
		propertyAt: #adminGroup
		ifAbsentPut: [ PUGroup named: 'admin' ].! !

!PRKernel methodsFor: '*pier-security-defaults' stamp: 'lr 1/7/2006 14:43'!
adminUser
	^ self 
		propertyAt: #adminUser
		ifAbsentPut: [
			(PUUser named: 'admin')
				password: 'pier';
				superuser: true;
				addGroup: self adminGroup;
				yourself ].! !

!PRKernel methodsFor: '*pier-security-accessing' stamp: 'lr 1/5/2006 14:13'!
groups
	^ self propertyAt: #groups ifAbsentPut: [ Set with: self adminGroup ].! !

!PRKernel methodsFor: '*pier-security-accessing' stamp: 'lr 1/5/2006 14:13'!
users
	^ self propertyAt: #users ifAbsentPut: [ Set with: self adminUser ].! !

MAError subclass: #PUInvalidLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!
